package ru.myitschool.work.data

import ru.myitschool.work.data.local.CredentialsLocalDataSource
import ru.myitschool.work.data.network.AdminNetworkDataSource
import ru.myitschool.work.domain.admin.AdminRepository

class AdminRepositoryImpl(
    private val networkDataSource: AdminNetworkDataSource,
    private val localCredentialsLocalDataSource: CredentialsLocalDataSource
) : AdminRepository {
    override suspend fun blockUser(login: String): Result<Unit> {
        return networkDataSource.blockUser(login, localCredentialsLocalDataSource.getToken())
    }

    override suspend fun unblockUser(login: String): Result<Unit> {
        return networkDataSource.unblockUser(login, localCredentialsLocalDataSource.getToken())
    }
}