package ru.myitschool.work.data.network

import io.ktor.client.request.headers
import io.ktor.client.request.patch
import io.ktor.http.HttpHeaders
import io.ktor.http.HttpStatusCode
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.withContext
import ru.myitschool.work.core.Constants.SERVER_ADDRESS

object AdminNetworkDataSource {

    private val client = KtorClient.client

    suspend fun blockUser(login: String, token: String): Result<Unit> =
        withContext(Dispatchers.IO) {
            runCatching {
                val response = client.patch("$SERVER_ADDRESS/api/users/block?username=$login") {
                    headers {
                        append(HttpHeaders.Authorization, token)
                    }
                }

                if (response.status != HttpStatusCode.OK)
                    error("Status ${response.status}")
                Unit
            }
        }

    suspend fun unblockUser(login: String, token: String): Result<Unit> =
        withContext(Dispatchers.IO) {
            runCatching {
                val response = client.patch("$SERVER_ADDRESS/api/users/unblock?username=$login") {
                    headers {
                        append(HttpHeaders.Authorization, token)
                    }
                }

                if (response.status != HttpStatusCode.OK)
                    error("Status ${response.status}")
                Unit
            }
        }
}
