package ru.myitschool.work.ui.login

import android.content.Context
import android.os.Bundle
import android.view.View
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import androidx.navigation.fragment.findNavController
import ru.myitschool.work.R
import ru.myitschool.work.core.Constants
import ru.myitschool.work.data.local.CredentialsLocalDataSource
import ru.myitschool.work.utils.collectWithLifecycle

class SplashFragment : Fragment(R.layout.fragment_splash) {

    private val viewModel by viewModels<LoginViewModel> { LoginViewModel.Factory }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        CredentialsLocalDataSource.buildSource(
            requireActivity().getSharedPreferences(
                Constants.TOKEN_KEY,
                Context.MODE_PRIVATE
            )
        )
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {

        viewModel.action.collectWithLifecycle(this) { action ->
            val navController = findNavController()
            when (action) {
                is LoginViewModel.Action.GoToLogin -> navController.navigate(R.id.loginFragment)
                is LoginViewModel.Action.OpenApp ->
                    navController.navigate(R.id.action_splashFragment_to_userFragment)
            }

        }
    }
}